﻿using HtmlAgilityPack;
using System;
using System.IO;
using System.Windows.Forms;

namespace HtmlContents
{
   public class ContentsGenerator
   {
      static String s = "";

      public static String GenerateContents(String fileName, String Tag, String ClassName)
      {
         string html;
         s = "";
         try
         {
            html = File.ReadAllText(fileName);
         }
         catch (Exception)
         {
            MessageBox.Show("Datei kann nicht geöffnet werden");
            return "";
         }


         var doc = new HtmlAgilityPack.HtmlDocument();
         doc.LoadHtml(html);
         return iterateAll(doc.DocumentNode, Tag, ClassName);
      }

      static String iterateAll(HtmlNode node, String TagName, String ClassName)
      {
         if (node.Name == "h1" || node.Name == "h2" || node.Name == "h3")
         {
            int level = Int32.Parse(node.Name.Substring(1));
            String id = node.GetAttributeValue("id", "noid");
            String text = node.InnerText;
            s += "<" + TagName + " class=\"" + ClassName + level + "\"><a href=\"#" + id + "\">" + text + "</a></" + TagName + ">\r\n";

         }
         foreach (var child in node.ChildNodes)
         {
            iterateAll(child, TagName, ClassName);
         }
         return s;
      }

      public static String GenerateTemplate(String TagName, String ClassName)
      {
         return "<" + TagName + " class=\"" + ClassName + "{LEVEL}\"><a href=\"#{ID}\">{TEXT}</a></" + TagName + ">";
      }
   }
}
